#ifndef PLAYER_H
#define PLAYER_H

#include "Rectangle.h"
#include "Actor.h"

/*it represents the player (the actor that is moved by the user)*/
class Player : public Rectangle
{
    public:
        Player(int axleft, int aytop);
        virtual ~Player();

/*methods that are connected to the user interface*/
        void moveLeft();
        void moveRight();
        void jump();

        void step();

        void interact(Actor* actor);

    protected:
    private:
        int jumping_state = 0;
        bool overSomething = false;
};

#endif // PLAYER_H
