#include "allegro5/allegro_primitives.h"
#include <iostream>

#include "Actor.h"


Actor::Actor(int axleft, int aytop, int awidth, int aheight) : xleft(axleft), ytop(aytop), width(awidth), height(aheight)
{
    std::cout << "construction of an actor";
}

Actor::~Actor()
{
    //dtor
}






void Actor::setXleft(int axleft)
{
    xleft = axleft;
}


int Actor::getXLeft()
{
    return xleft;
}


void Actor::setXright(int axright)
{
    xleft = axright - width;
}

int Actor::getXRight()
{
    return xleft + width;
}

void Actor::setYTop(int aytop)
{
    ytop = aytop;
}

int Actor::getYTop()
{
    return ytop;
}

void Actor::setYBottom(int aybottom)
{
    ytop = aybottom - height;
}

int Actor::getYBottom()
{
    return ytop + height;
}






bool isRectanglesIntersect(int l1, int r1, int t1, int b1, int l2, int r2, int t2, int b2)
{
    if(r1 <= l2)
        return false;

    if(r2 <= l1)
        return false;

    if(b1 <= t2)
        return false;

    if(b2 <= t1)
        return false;

    return true;
}


bool isRectangle1Over2(int l1, int r1, int t1, int b1, int l2, int r2, int t2, int b2)
{
    if(r1 <= l2)
        return false;

    if(r2 <= l1)
        return false;

    return (b1 >= t2) && (b1 < t2 + 10);


}



bool Actor::isIntersect(Actor* r)
{
    return isRectanglesIntersect(getXLeft(), getXRight(), getYTop(), getYBottom(), r->getXLeft(), r->getXRight(), r->getYTop(), r->getYBottom());

}




bool Actor::isOver(Actor* r)
{
    return isRectangle1Over2(getXLeft(), getXRight(), getYTop(), getYBottom(), r->getXLeft(), r->getXRight(), r->getYTop(), r->getYBottom());

}






















