#ifndef PLATFORMERWORLD_H
#define PLATFORMERWORLD_H


#include "World.h"
#include "Player.h"

/*this class implements a world for a platformer.*/
class PlatformerWorld : public World
{
public:
    PlatformerWorld();
    virtual ~PlatformerWorld();



    void playerMoveLeft();
    void playerMoveRight();
    void playerJump();



    bool isGameover();
protected:
    /*add the actor which is the player*/
    void addPlayer(Player* player);

    /*returns the player*/
    Player* getPlayer();


private:
    Player* player;
};

#endif // PLATFORMERWORLD_H
